        DSEG
Px3	Bit	7Eh
	CSEG

RS	Bit	P1.0
RW	Bit	P1.1
E_Clock	Bit	P1.2

	Org	$
Init_LCD:
	Lcall	Delay_20mS
	Clr	E_Clock			;E Clock diberi kondisi awal low
	Mov	A,#30H			;Kirim 30H
	Acall	Kirim_Perintah		;
	Lcall	Delay_5mS

	Mov	A,#30H			;Kirim 30H
	Acall	Kirim_Perintah		;
	Lcall	Delay_5mS

	Mov	A,#30H			;Kirim 30H
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy
	
	Mov	A,#20H			;Send Init
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy

	Mov	A,#2FH			;8x5 2lines
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy
	
	Mov	A,#08H			;
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy
	
	Mov	A,#01H			;
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy

	Mov	A,#07H			;
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy

	Mov	A,#0CH			;Display ON
	Acall	Kirim_Perintah		;Cursor OFF
	Acall	Tunggu_Busy

	Mov	A,#06H			;Mode Increment Address
	Acall	Kirim_Perintah		;
	Acall	Tunggu_Busy
	Ret

;*********************************************
;* Pengiriman data ke LCD ada 2 macam yaitu:
;* - Pengiriman perintah di mana data yang dikirim masuk ke Control Register
;*   RS = 0
;* - Pengiriman karakter di mana data yang dikirim masuk ke Data Register
;*   RS = 1
;*********************************************
Kirim_Perintah:
	Clr	RS
	Acall	Kirim_DataLCD		;Kirim High Nibble ke LCD
	Swap	A			;
	Acall	Kirim_DataLCD		;Kirim Low Nibble ke LCD
	Acall	Tunggu_Busy
	Ret

Kirim_Karakter:
	Setb	RS	
	Acall	Kirim_DataLCD		;Kirim High Nibble ke LCD
	Swap	A			;
	Acall	Kirim_DataLCD		;Kirim Low Nibble ke LCD
	Acall	Tunggu_Busy
	Ret

;*******************
;* Subroutine ini digunakan oleh subroutine kirim karakter ataupun
;* kirim perintah untuk mengirimkan data ke LCD dengan teknik 4 bit interface
;*******************
Kirim_DataLCD:
	Clr	RW			;LCD mode write
	Push	ACC			;Simpan data yang dikirim di Stack	
	Anl	A,#0F0H			;Hapus bit 3 ... bit 0 dari data
                                        ;yang dikirim
	Anl	P1,#0FH			;Hapus bit 4 ... bit 7 dari Port 1
	Orl	A,P1			;Pindahkan bit 4 .. bit 7 dari data
					;tanpa mengganggu bit 3 ... bit 0
        Push    PSW
        Mov     C,Px3
        Mov     Acc3,C
        Pop     PSW
	Mov	P1,A			;Port 1
	Setb	E_Clock			;Beri 1 pulsa clock
	Clr	E_Clock			;
	Pop	ACC			;Ambil data yang dikirim dari Stack
	ret

Baca_DDRAM:
	Setb	RW			;LCD Mode Read
	Setb	RS			;Pembacaan Data Register, RS = 1
	Lcall	BacaData_LCD		;Baca Data High Nibble
	Push	ACC			;
	Lcall	BacaData_LCD		;Baca Data Low Nibble
	Pop	B			;
	Swap	A			;Gabungkan High Nibble
	Add	A,B			;dan Low Nibble
	Ret

Baca_IR:
	Setb	RW			;LCD Mode Read
	Clr	RS			;Pembacaan Register Instruksi, RS = 0
	Lcall	BacaData_LCD		;Baca Data High Nibble
	Push	ACC			;
	Lcall	BacaData_LCD		;Baca Data Low Nibble
	Pop	B			;
	Swap	A			;Gabungkan High Nibble
	Add	A,B			;dan Low Nibble
	Ret


BacaData_LCD:
	Orl	P1,#0F0H		;Jadikan P1.4 .. P1.7 sebagai
					;input tanpa mengganggu P1.0 ... P1.3
	Setb	E_Clock			;Clock high
	Mov	A,P1			;Ambil data dari Port 1
	Clr	E_Clock			;Clock Low
	Anl	A,#0F0H			;Hapus bit 3 ... bit 0
	Ret

;Rutin-rutin perintah LCD
Baris2_LCD:
	Mov	A,#0C0H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

Baris1_LCD:
	Mov	A,#02H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

;----------------------
;Geser Display ke kanan

GeserDisplay_Kanan:
	Mov	A,#1FH
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

;----------------------
;Geser Display ke kiri

GeserDisplay_Kiri:
	Mov	A,#18H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

;----------------------
;Kembali ke posisi awal

Posisi_Awal:
	Mov	A,#02H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

;----------------------
;Geser Cursor ke kiri

GeserCursor_Kiri:
	Mov	A,#10H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret

;----------------------
;Geser Cursor ke kanan

GeserCursor_Kanan:
	Mov	A,#14H
	Acall	Kirim_Perintah
	Acall	Tunggu_Busy
	Ret


Tunggu_Busy:
	Push	ACC
LoopTunggu_Busy:
	Lcall	Baca_IR
	Jb	ACC7,LoopTunggu_Busy
	Pop	ACC
	Ret

Delay_20mS:
	Push	07H
	Mov	R7,#04H
LoopDelay_20mS:
	Lcall	Delay_5mS
	Djnz	R7,LoopDelay_20mS
	Pop	07H
	Ret

KirimPesan_LCD:
LoopKirimPesan_LCD:
	Mov	A,#00H			;Ambil data dari memori yg ditunjuk
	Movc	A,@A+Dptr		;
	Cjne	A,#0FH,Kirim_LCD	;Kirim ke LCD selama belum ditemukan
	Ret				;0FH
	
Kirim_LCD:
	Acall	Kirim_Karakter
	Inc	Dptr			;Tunjuk ke memori selanjutnya
	Ajmp	LoopKirimPesan_LCD

OutLCD2B:
	Lcall	Hex_ASCII2
	Push	B
	Lcall	Kirim_Karakter
	Pop	B
	Xch	A,B
	Lcall	Kirim_Karakter
	Ret

OutLCD1B:
	Add	A,#30h
	Lcall	Kirim_Karakter
	Ret


Clear1Baris:
	Push	07
	Mov	R7,#16
LoopClear1Baris:
	Mov	A,#' '
	Lcall	Kirim_Karakter
	Djnz	R7,LoopClear1Baris

	Pop	07
	Ret