LihatSetting:
	Mov	DPTR,#NomorHPOwner
	Mov	R5,#38
LoopOutField2:
	Mov	R7,#17
	Lcall	OutField
	Lcall	Enter_Code
	Djnz	R5,LoopOutField2
	Ljmp	$




; - Ganti copy menggunakan buffer RAM dan memori EEPROM AT89S8253

;================================================================
; KIRIM ISI FIELD KE SERIAL
; - Kirim isi alamat yang ditunjuk DPTR sejumlah R7 ke port serial

OutField:
	Mov	R0,#BufferField
	Mov	R7,#00
LoopOutField:
	Push	06
	Lcall	BacaEEPROM
;	Lcall	Serial_Out
	Mov	@R0,A
	Inc	R0
	Inc	R7
	Add	A,CheckSum
	Mov	CheckSum,A
	Inc	DPTR
	Pop	06
	Djnz	R6,LoopOutField

	Mov	R0,#BufferField
Loop2OutField:
	Mov	A,@R0
	Lcall	Serial_Out
	Inc	R0
	Djnz	R7,Loop2OutField

	Ret

;================================================================
; ISI FIELD DARI SERIAL KE SERIAL EEPROM 8 BIT
; - Alamat ditunjuk oleh DPTR sesuai index R4 x 17 (Tunjuk Tabel)
; - Jumlah maksimum 16 atau bila ada 0Dh
; - Akhir data = 00h
; - Data disimpan di Serial EEPROM 8bit

IsiField:
	Push	DPH
	Push	DPL
	Lcall	TunjukTabel


	Mov	R0,#BufferField
	Mov	R6,#16
	Mov	R7,#00
LoopIsiField:
	Lcall	Serial_In

	Mov	WDT,#11111011b
	Mov	0A6h,#01eh
	Mov	0A6h,#0E1h
	Cjne	A,#0Dh,IsiFieldterus
	Ljmp	SelesaiIsiField

IsiFieldterus:
	Push	06
;	Lcall	TulisEEPROM

	Mov	@R0,A
	Inc	R0
	Inc	R7
	Pop	06
;	Inc	DPTR
	Djnz	R6,LoopisiField
SelesaiIsiField:
;	Lcall	TulisEEPROM
	Mov	@R0,#00


	Inc	R7
	Push	07
	Push	DPH
	Push	DPL
	Mov	R0,#BufferField
;	mov	a,dph
;	lcall	serial_out
;	mov	a,dpl
;	lcall	serial_out
	Mov	WDT,#11111011b
	Mov	0A6h,#01eh
	Mov	0A6h,#0E1h


	Lcall	TulisEEPROMPage	
	Mov	WDT,#11111011b
	Mov	0A6h,#01eh
	Mov	0A6h,#0E1h


	Pop	DPL
	Pop	DPH
	Pop	07

;	Mov	R0,#BufferField
;Loo:
;	Lcall	BacaEEPROM
;	Lcall	Serial_Out
;	Inc	DPTR
;	Djnz	R7,Loo
;


	Mov	A,#00
	Pop	DPL
	Pop	DPH
	Ret	

;================================================================
; HAPUS FIELD
; - Hapus 32 byte data field dalam Serial EEPROM 8 bit

HapusField:
	Mov	R7,#KapasitasField
	Mov	A,#00
LoopHapusField:
	Push	07
	Lcall	TulisEEPROM
	Pop	07
	Inc	DPTR
	Djnz	R7,LoopHapusField
	Ret


;================================================================
; TUNJUK TABEL SESUAI INDEKS
; DPTR = DPTR + 16 * R4

TunjukTabel:
	Mov	A,R4
	Mov	B,#16
	Mul	AB

	Push	B
	Push	PSW
	Lcall	AddADPTR
	Pop	PSW
	Pop	B
	Mov	A,B
	Jz	TidakTambahLagi
	Inc	DPH
	
TidakTambahLagi:
	Ret


;================================================================
; UPLOAD ISI SETTING
; - Upload Nomor HP 14 byte + 0D
; - Upload Pesan I/O 16 byte + 0D
; - Upload Alarm 16 byte + 0D

UploadSetting:
	Mov	DPTR,#NomorHPOwner
	Mov	R5,#JumlahHP
	Mov	R4,#00
	Mov	CheckSum,#00
LoopLihatHP:
	Push	DPH
	Push	DPL
	Mov	R6,#14
	Lcall	TunjukTabel
	Lcall	OutField
	Mov	A,#0Dh
	Lcall	Serial_Out
	Add	A,CheckSum
	Mov	CheckSum,A
	Inc	R4
	Pop	DPL
	Pop	DPH
	Djnz	R5,LoopLihatHP	

	Mov	DPTR,#PesanRelayON
	Mov	R5,#JumlahIO*2
	Mov	R4,#00
LoopLihatIO:
	Push	DPH
	Push	DPL
	Mov	R6,#16
	Lcall	TunjukTabel
	Lcall	OutField
	Mov	A,#0Dh
	Lcall	Serial_Out
	Add	A,CheckSum
	Mov	CheckSum,A
	Inc	R4
	Pop	DPL
	Pop	DPH
	Djnz	R5,LoopLihatIO

	Mov	DPTR,#PesanAlarm
	Mov	R5,#JumlahAlarm
	Mov	R4,#00
LoopLihatAlarm:
	Push	DPH
	Push	DPL
	Lcall	TunjukTabel
	Mov	R6,#16
	Lcall	OutField
	Mov	A,#0Dh
	Lcall	Serial_Out
	Add	A,CheckSum
	Mov	CheckSum,A
	Inc	R4
	Pop	DPL
	Pop	DPH
	Djnz	R5,LoopLihatAlarm
	Mov	A,CheckSum
	Lcall	Serial_Out
	Ret	
	
;================================================================
; HAPUS ISI MEMORI SETTING
; - Hapus Nomor HP
; - Hapus Pesan IO
; - Hapus Pesan Alarm

HapusMemoriSetting:
	Mov	DPTR,#NomorHPOwner
	Mov	R5,#JumlahHP
LoopHapusNoHP:
	Lcall	HapusField
	Djnz	R5,LoopHapusNoHP	

	Mov	R5,#JumlahIO*2
LoopHapusIO:
	Lcall	HapusField
	Djnz	R5,LoopHapusIO

	Mov	R5,#JumlahAlarm
LoopHapusAlarm:
	Lcall	HapusField
	Djnz	R5,LoopHapusAlarm
	Ret

;================================================================
; DOWNLOAD ISI SETTING
; - Download No HP dan dibalas 0D 0A
; - Download Pesan IO dan dibalas 0D 0A
; - Download Pesan Alarm dan dibalas 0D 0A
; - Download data jam 3 byte dan dibalas 0D 0A

DownloadSetting:
	Mov	R5,#JumlahHP
	Mov	DPTR,#NomorHPOwner
	Mov	R4,#00
LoopIsiNoHP:
	Mov	WDT,#11111011b
	Mov	0A6h,#1Eh
	Mov	0A6h,#0E1h
	Lcall	IsiField
	Lcall	Enter_Code
	Inc	R4
	Mov	WDT,#11111011b
	Mov	0A6h,#1Eh
	Mov	0A6h,#0E1h

	Djnz	R5,LoopIsiNoHP

	

	Mov	R5,#JumlahIO*2
	Mov	DPTR,#PesanRelayON
	Mov	R4,#00
LoopIsiPesanRelay:
	Lcall	IsiField
	Lcall	Enter_Code
	Inc	R4
	Djnz	R5,LoopIsiPesanRelay

	Mov	R5,#JumlahAlarm
	Mov	DPTR,#PesanAlarm
	Mov	R4,#00
LoopIsiPesanAlarm:
	Lcall	IsiField
	Lcall	Enter_Code
	Inc	R4
	Djnz	R5,LoopIsiPesanAlarm

	Lcall	Serial_In
	Lcall	Serial_In
	Lcall	Serial_In
	Lcall	Enter_Code
	Ret

