$MOD51

;DeviceID	EQU	057h		;ID Telemeter

BeaconLamp	Bit	P0.3
SensorAir	Bit	P3.2
SensorCahaya	Bit	P3.3

PowerKey	Bit	P3.5
SIMVDD		Bit	P3.4
PrgSW		Bit	P3.7

	
Indicator	Bit	P2.7


	DSEG
	Org	30H
PTR:	Ds	2
RAM_ID:		Ds	1
RAM_HPServer:	Ds	15
RAM_OperatorNumber:	Ds	10
TF0Counter:	Ds	1
IndexSMS:	Ds	1
IndexPerintah:	Ds	1
CheckSum:	Ds	1
PrescaleTimer:	Ds	1
CounterHP:	Ds	1
SamplingTime:	Ds	1
Flag:		Ds	1		
					;
LastFlag:	Ds	1		;Variabel penyimpan kondisi flag sebelumnya
Flag3:		Ds	1		;Flag Serba guna
temp:		Ds	1
BufferGPS:	Ds	24


EECON	EQU	96h
WDT	EQU	0A7h

	CSEG
	Org	000H
	Ljmp	Start
	Org	003H
	REti
	Org	00Bh
	Ljmp	Timer0Interrupt
	Org	013H
	Reti
	Org	023h
	Reti



;============================================
; Kalau Call Ready = GSM On
; Kalau 's' = koneksi dengan PC


CallReady:
	DB	0Dh,0Ah,'Call Ready',0Dh,0Ah,00

TurnOFFGSM:
	Lcall	PowerButton				;Turn OFF GSM
	Lcall	TungguEnter
	Lcall	TungguEnter

	Ljmp	GSMSudahOFF




LoopPrograms:
	Ljmp	LoopProgram

Start:

	Mov	R7,#10
LoopDelay:
	Lcall	Delay_1detik
	Djnz	R7,LoopDelay

	Mov	Flag3,#0FFh

	Mov	R0,#BufferGPS
	Mov	R7,#24

LoopHapusBuffer:
	Mov	@R0,#00
	Inc	R0
	Djnz	R7,LoopHapusBuffer

NoDefault:
	Lcall	Init_Serial			;Inisial Serial 11.5200
	Clr	RI
	Clr	TI
	Jnb	PrgSW,LoopPrograms
	Jb	SIMVDD,TurnOFFGSM		;Cek GSM aktif?

GSMSudahOFF:

	Setb	BeaconLamp			;BeaconLamp OFF
	Lcall	Init_LCD
	Lcall	StandbyLCD


	Jnb	SensorAir,$			;Sensor air tidak aktif, standby
	Lcall	PowerButton
	Lcall	TungguEnter			;Tunggu Call Ready
	Lcall	TungguEnter			;
	Lcall	Init_LCD
	Mov	DPTR,#PesanLCDAktif
	Lcall	KirimPesan_LCD
	Lcall	InitGSM

LoopUtama:
	Setb	BeaconLamp
	Jb	SensorCahaya,SiangHari
	Clr	BeaconLamp			;Aktifkan Beacon Lamp
SiangHari:

UlangGPS:
	Lcall	AmbilGPSValue			;Ambil data GPS
	Mov	R0,#BufferOutbox
	Mov	A,@R0
	Cjne	A,#'0',$+3
	Jc	UlangGPS
	Cjne	A,#'9',$+3
	Jnc	UlangGPS
	Lcall	Init_LCD			;
	Mov	R0,#BufferOutbox		;

	Lcall	DisplayCoordkeLCD		;Tampilkan ke LCD
	Lcall	Baris2_LCD			;
	Inc	R0				;
	Lcall	DisplayCoordkeLCD		;

	Mov	R7,#10

LoopDelayGSM:
	Lcall	Delay_1detik
	Djnz	R7,LoopDelayGSM

	Mov	R0,#BufferOutbox
	Mov	R1,#BufferGPS
	Lcall	CekLokasi
	Jc	KirimDataLokasi


	Mov	R7,#2

LoopCariKoma:
	Mov	A,@R0
	Inc	R0
	Cjne	A,#',',LoopCarikoma
	Djnz	R7,LoopCariKoma


	Mov	R7,#2

LoopCariKoma2:
	Mov	A,@R1
	Inc	R1
	Cjne	A,#',',LoopCarikoma2
	Djnz	R7,LoopCariKoma2

	Lcall	CekLokasi
	Jc	KirimDataLokasi
	LJmp	SkipKirimDataLokasi


KirimDataLokasi:
	Mov	R0,#BufferOutbox

CariAkhirBufferGPS:
	Mov	A,@R0
	Inc	R0
	Jnz	CariakhirBufferGPS
	Dec	R0
	Mov	@R0,#','
	Inc	R0
	Mov	DPTR,#PesanRelayON
	Lcall	CopySEEtoRAM2	
	Mov	@R0,#','
	Inc	R0
	Mov	DPTR,#PesanRelayON+16
	Lcall	CopySEEtoRAM2	
	Mov	@R0,#','
	Inc	R0
	Mov	DPTR,#PesanRelayON+128

	Lcall	CopySEEtoRAM2	
	Mov	@R0,#00
	Lcall	KirimWarning

SkipKirimDataLokasi:

	Mov	R1,#BufferOutbox
	Mov	R0,#BufferGPS
	Mov	R7,#24
	Lcall	CopyRAMtoRAM

	Ljmp	LoopUtama






	Mov	R0,#BufferGPS
	Mov	R7,#24

LoopOutgps:
	Mov	A,@R0
	Inc	R0
	Lcall	Serial_Out
	Djnz	R7,Loopoutgps


	Ljmp	$


CekLokasi:
LoopCekLokasi:
	Mov	A,@R0
	Cjne	A,#'.',CekTerus
	Clr	C
	Ret

CekTerus:
	Mov	B,@R1
	Inc	R0
	Inc	R1
	Clr	C
	Subb	A,B
	Jnz	PindahLokasi
	Ljmp	LoopCekLokasi	

PindahLokasi:
	Setb	C
	Ret




LoopProgram:
	Lcall	Init_Serial
	Lcall	Serial_In
	Mov	B,A
	Mov	DPTR,#TabelPerintahProgram
	Lcall	CariPerintah1B

	Jc	LoopProgram

	Jmp	@A+DPTR



;================================================================
; MENU PERINTAH SERIAL
Program:
	Mov	A,#'S'
	Lcall	Serial_Out
	Ljmp	LoopProgram

Download:
	Mov	A,#0EDh
	Lcall	Serial_Out
	Lcall	DownloadSetting
	Ljmp	LoopProgram


HapusMemori:	
	Lcall	HapusMemoriSetting
	Mov	DPTR,#MemIOStatus
	Mov	A,#0FFh
	Lcall	TulisEEPROM
	Mov	A,#0EEh
	Lcall	Serial_Out
	Ljmp	LoopProgram

Upload:
	Mov	A,#0ECh
	Lcall	Serial_Out
	Lcall	UploadSetting
	Ljmp	LoopProgram
	

TabelPerintahProgram:
	DB	's'
	DW	Program

	DB	0D0h
	DW	Download

	DB	0Eh
	DW	HapusMemori

	DB	0Ch
	DW	Upload
	DB	0


	


Timer0Interrupt:
	Push	ACC
	Push	PSW
	Push	B
	Push	DPH
	Push	DPL
	Push	00
	Push	01
	Push	IE
	Clr	EA


	Lcall	ResetTimer			;Reset Timer

BackManSwitch:


	Inc	TF0Counter			;
	Mov	A,TF0Counter			;

	Mov	B,PrescaleTimer			;
	Clr	C				;
	Subb	A,B				;
	Jnz	Belum1detik			;
	Mov	TF0Counter,#00			;Blink Indicator
	Cpl	Indicator			;



Belum1detik:
	Lcall	ResetTimer


	Pop	IE
	Pop	01
	Pop	00
	Pop	DPL
	Pop	DPH
	Pop	B
	Pop	PSW
	Pop	ACC
	Reti


 


InitTimer:
	Mov	TMOD,#21h
	Lcall	ResetTimer
	Reti

ResetTimer:
	Mov	TH0,#0DCh
	Mov	TL0,#00
	Ret





ClearBufferPerintah:
	Push	07
	Mov	R7,#16
	Mov	R0,#BufferPerintah
LoopClearBuffer:
	Mov	@R0,#' '
	Inc	R0
	Djnz	R7,LoopClearBuffer
	Pop	07
	Ret
;=====================================================================
; JUMLAHKAN ISI DPTR DENGAN AKUMULATOR
AddADPTR:
	Add	A,DPL			;
	Mov	DPL,A			;
	Mov	A,#00			;
	Addc	A,DPH			;
	Mov	DPH,A			;
	Ret


;======================================================================
;
; BANDINGKAN STRING DI RAM DENGAN FIX DATA DI TABEL MEMORI
; - Capital non sensitive
; - Jumlah string tergantung R7
; - Carry Flag clear bila Match dan set bila not match
; - Berhenti bila ditemukan zero

CompareString:
	Push	DPH
	Push	DPL
LoopCompareString:
	Mov	A,@R0
	Inc	R0
	Lcall	Capitalize
	Mov	B,A
	Mov	A,#00
	Movc	A,@A+DPTR
	Jz	StringNotMatch
	Inc	DPTR
	Clr	C
	Subb	A,B
	Jnz	StringNotMatch
	Djnz	R7,LoopCompareString
	Pop	DPL
	Pop	DPH
	Clr	C
	Ret

StringNotMatch:
	Pop	DPL
	Pop	DPH
	Setb	C
	Ret



;======================================================================
;
; BANDINGKAN STRING DI RAM DENGAN SETTING DATA DI SERIAL EEPROM
; - Capital non sensitive
; - Jumlah string tergantung R7
; - Carry Flag clear bila Match dan set bila not match
; - Berhenti bila ditemukan zero

CompareSEEString:
	Push	DPH
	Push	DPL
LoopCompareSEEString:
	Mov	A,@R0
	Inc	R0
	Lcall	Capitalize
	Mov	B,A
	Push	B
	Push	07
	Lcall	BacaEEPROM
	Lcall	Capitalize

	Pop	07
	Pop	B
	Jz	StringSEEMatch
	Inc	DPTR
	Clr	C
	Subb	A,B
	Jnz	StringSEENotMatch
	Djnz	R7,LoopCompareSEEString

StringSEEMatch:
	Pop	DPL
	Pop	DPH
	Clr	C
	Ret

StringSEENotMatch:
	Pop	DPL
	Pop	DPH
	Setb	C
	Ret




PowerButton:
	Clr	PowerKey
	Mov	R7,#04
	Clr	EA
	Clr	TF0
LoopDelayONGSM:
	Lcall	Delay_1detik
	cpl	indicator
	Djnz	R7,LoopDelayONGSM
	Setb	PowerKey
	Ret



DisplayCoordkeLCD:
	Mov	A,@R0
	Inc	R0
	Cjne	A,#',',Displayterus
	Lcall	Kirim_Karakter
	Mov	A,@R0
	Inc	R0
	Lcall	Kirim_Karakter
	Ret

Displayterus:
	Lcall	Kirim_Karakter
	Ljmp	DisplayCoordkeLCD


StandbyLCD:
	Mov	DPTR,#PesanStandby
	Lcall	KirimPesan_LCD
	Ret

PesanStandby:
	DB	'SYSTEM STANDBY',0Fh

PesanLCDAktif:	
	DB	'SYSTEM ACTIVE',0Fh


;=========================================================================
; KIRIM ISI PESAN ALARM KE SMS 
; - Skip nomor-nomor yang belum diprogram


KirimWarning:
	Push	IE
	Clr	EA
	Mov	CounterHP,#0
Loop2KirimWarning:
	Mov	DPTR,#NomorHPOwner
	Mov	R4,CounterHP
	Mov	A,R4
	Jz	SkipTunjuk3
	Lcall	TunjukTabel
SkipTunjuk3:
	Lcall	BacaEEPROM
	Jz	SkipKirim2
	Mov	R0,#BufferHPTujuan
	Lcall	CopySEEtoRAM2
	Mov	@R0,#00
	Lcall	KirimSMS	
	Cpl	Indicator
SkipKirim2:
	Inc	CounterHP
	Mov	A,CounterHP
	Cjne	A,#JumlahHP,Loop2KirimWarning
	Pop	IE
	Ret

CompareSerial2:
CompareTerus2:
	Lcall	SerialInIO2
	Mov	B,A
	Mov	A,#00
	Movc	A,@A+DPTR
	Jz	Match
	Inc	DPTR
	Clr	C
	Subb	A,B
	Jnz	ErrorCompare
	Ljmp	CompareTerus2

ErrorCompare:
	Setb	C
	Ret

Match:
	Mov	A,B
	Clr	C
	Ret



TabelGPRMC:
	DB	'GPRMC',0
;=======================================================================
; AMBIL NILAI GPS DAN SIMPAN DI BUFFER OUTBOX

AmbilGPSValue:
Tunggudollar:
	Lcall	SerialInIO2
	Cjne	A,#'$',Tunggudollar
	Mov	DPTR,#TabelGPRMC	
	Lcall	CompareSerial2
	Jc	Tunggudollar
	Lcall	SerialInIO2			;Buang koma
TungguKoma:
	Lcall	SerialInIO2
	Cjne	A,#',',TungguKoma
	Lcall	SerialInIO2
	Cjne	A,#'A',NoGPSData
	Lcall	SerialInIO2

	Mov	R0,#BufferOutbox
	Mov	R7,#25
LoopDataInput:
	Lcall	SerialInIO2
	Mov	@R0,A
	Inc	R0
	Djnz	R7,LoopDataInput
	Mov	@R0,#00	

NoGPSData:
	Ret



	
	$include	(lcd.asm)
	$include	(cariprnt.asm)
	$include	(hexascii.asm)
	$include	(out.asm)
	$include	(ascii_he.asm)
	$include	(delay_1d.asm)
	$include	(capital.asm)

	$include	(program.asm)
	$include	(sms.asm)
	$include	(memori.asm)
	$include	(movemem.asm)
	$include	(serialio.asm)

	DSEG
BufferHPTujuan:	Ds	15
BufferPerintah:	Ds	16
BufferOutBox:	Ds	16
BufferField:	Ds	20
BufferWaktu:	Ds	20


	$include	(default.asm)
	END
